import java.util.Random;

public class MultithreadMonitorReaderWriter implements Runnable
{
    int count = 0;
    String threadName;
    Thread t;
    SharedBuffer buffer;

    MultithreadMonitorReaderWriter(String name, SharedBuffer buffer) {
        threadName = name;
        this.buffer = buffer;
      }

    public int RandomValue(int min, int max) {
        int intValue = (int) (Math.random() * max) + min;
        return intValue;
    }

    public void writer() {
        for (int i =0; i < 20; i++) {
            int item = RandomValue(200,500);
            System.out.println("Writer " + threadName + "[" + i + "] = " + item);
            buffer.Put(item);
        }
    }

    public void reader() {
        while (true) {
            System.out.println("                Reader " + threadName);
            int item = buffer.Get();
        }
    }

    public void run() {
        if (threadName.equals("WriterThread")) {
            System.out.println("RUN WRITER " + threadName + "....................");
            writer();
            try {
                Thread.sleep(2000);
            }
            catch (InterruptedException e) {
            }
        }
        else {
            System.out.println(".......................RUN Reader " + threadName);
            reader();
            try {
                Thread.sleep(1000);
            }
            catch (InterruptedException e) {
            }
        }
    }

    public void start ()
    {
        System.out.println("Starting " +  threadName );
        if (t == null)
        {
            t = new Thread (this, threadName);
            t.start ();
        }
    }

    public static void main(String[] args) {
        System.out.println("MultithreadMonitorReaderWriter");

        SharedBuffer buffer = new SharedBuffer(5);

        MultithreadMonitorReaderWriter writer = new MultithreadMonitorReaderWriter("WriterThread", buffer);
        writer.start();
        try {
            Thread.sleep(10);
        }
        catch (InterruptedException e) {
        }

        MultithreadMonitorReaderWriter reader1 = new MultithreadMonitorReaderWriter("ReaderThread 1", buffer);
        reader1.start();

        MultithreadMonitorReaderWriter reader2 = new MultithreadMonitorReaderWriter("ReaderThread 2", buffer);
        reader2.start();
    }
}