import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
//import java.util.concurrent.lock.Lock;

public class SharedBuffer {
    private volatile int [] buffer;
    private volatile int count = 0, in = 0, out = 0;

    SharedBuffer(int size)
    {
        buffer = new int[size];
    }

    public synchronized void Put(int value)
    {
        System.out.println(" Put count = " + count);
        while (count == buffer.length)
        {
            System.out.println(" Full buffer - Cannot put more data. So, Wait");
            try { wait(); } // wait
            catch (InterruptedException e) { }
            finally { }
        }
        System.out.println(" Producing " + value + " ...");
        buffer[in] = value;
        in = (in + 1) % buffer.length;
        count++;
        notify(); // signal
        //if (count == 1) notify();
    }

    public synchronized int Get()
    {
        while (count == 0)
        {
            System.out.println("                      Empty buffer - cannot get more data. So, Wait");
            try { wait(); } // wait
            catch (InterruptedException e) { }
            finally { }
        }
        System.out.println("                      Get count = " + count);
        int value = buffer[out];
        out = (out + 1) % buffer.length;
        count--;
        System.out.println("                      Consuming " + value + " ...");
        notify(); // signal
        //if (count == buffer.length - 1) notify();
        return value;
    }
}
